'
'
' ####################
' #####  PROLOG  #####
' ####################
'
PROGRAM	"xCheetah"
VERSION	"1.02"
CONSOLE

IMPORT  "gdi32"
IMPORT	"user32"
IMPORT	"kernel32"

EXPORT
DECLARE FUNCTION  InitXCheetah ()
END EXPORT

DECLARE FUNCTION  AddHeader$ (xbString$)
DECLARE FUNCTION  WndProc (hWnd, uMsg, wParam, lParam)

EXPORT
' DATABASE ROUTINES - Creation/Opening/Closing
DECLARE FUNCTION  xdbCreate						(dbFile$, @fieldArray$[])
DECLARE FUNCTION  xdbCreateExtended 	(fileName$, @fieldArray$[], MemoBlockSize, Algorithm, EncryptionKey$)
DECLARE FUNCTION  xdbOpen							(dbFile$)
DECLARE FUNCTION  xdbOpenEx						(dbFile$, accessMode, shareMode)
DECLARE FUNCTION  xdbAlias$						(dbHandle)
DECLARE FUNCTION  xdbSetAlias					(dbHandle, alias$)
DECLARE FUNCTION  xdbCreateFields			(fileName$)
DECLARE FUNCTION  xdbCreateFieldsExtended (fileName$, MemoBlockSize, Algorithm, EncryptionKey$)
DECLARE FUNCTION  xdbAddField					(fieldInfoString$)
DECLARE FUNCTION  xdbClose						(dbHandle)
DECLARE FUNCTION  xdbDatabaseHandles 	(fileName$, @CheetahHandle, @WindowsHandle)
DECLARE FUNCTION  xdbIndexHandles 		(iFileName$, @CheetahHandle, @WindowsHandle)

' DATABASE ROUTINES - Adding/Deleting Records
DECLARE FUNCTION  xdbAddRecord				(dbHandle)
DECLARE FUNCTION  xdbAppendRecord			(dbHandle)
DECLARE FUNCTION  xdbClearBuffer			(dbHandle)
DECLARE FUNCTION  xdbPutRecord				(dbHandle, recordNumber)
DECLARE FUNCTION  xdbGetRecord				(dbHandle, recordNumber)
DECLARE FUNCTION  xdbDeleteRecord			(dbHandle, recordNumber)
DECLARE FUNCTION  xdbRecallRecord			(dbHandle, recordNumber)
DECLARE FUNCTION  xdbDeleted					(dbHandle, recordNumber)
DECLARE FUNCTION  xdbFlushDatabase		(dbHandle)
DECLARE FUNCTION  xdbPack							(dbHandle)
DECLARE FUNCTION  xdbZap							(dbHandle)
DECLARE FUNCTION  xdbRecordBuffer$		(dbHandle)
DECLARE FUNCTION  xdbSpeedAppend			(dbHandle, trueFalse)

' DATABASE ROUTINES - Database Information
DECLARE FUNCTION  xdbRecordCount			(dbHandle)
DECLARE FUNCTION  xdbFieldCount				(dbHandle)
DECLARE FUNCTION  xdbFieldNumber			(dbHandle, fieldName$)
DECLARE FUNCTION  xdbRecordNumber			(dbHandle)
DECLARE FUNCTION  xdbLastUpdated			(dbHandle, @yearNr, @monthNr, @dayNr)
DECLARE FUNCTION  xdbFieldInfo				(dbHandle, fieldNumber, @fieldName$, @fieldType$, @fieldLength, @fieldDecimals)
DECLARE FUNCTION  xdbFieldName$				(dbHandle, fieldNumber)
DECLARE FUNCTION  xdbFieldType$				(dbHandle, fieldNumber)
DECLARE FUNCTION  xdbFieldLength			(dbHandle, fieldNumber)
DECLARE FUNCTION  xdbFieldDecimals		(dbHandle, fieldNumber)
DECLARE FUNCTION  xdbFieldPadding 		(dbHandle, TrueFalse)

' DATABASE ROUTINES - Navigating the Database
DECLARE FUNCTION  xdbEOF							(dbHandle)
DECLARE FUNCTION  xdbBOF							(dbHandle)
DECLARE FUNCTION  xdbMoveFirst				(dbHandle, idxHandle)
DECLARE FUNCTION  xdbMoveNext					(dbHandle, idxHandle)
DECLARE FUNCTION  xdbMoveLast					(dbHandle, idxHandle)
DECLARE FUNCTION  xdbMovePrev					(dbHandle, idxHandle)
DECLARE FUNCTION  xdbSkipDeleted			(dbHandle, trueFalse)

' DATABASE ROUTINES - Assigning Field Values
DECLARE FUNCTION  xdbAssignField			(dbHandle, fieldName$, fieldNumber, fieldString$)
DECLARE FUNCTION  xdbAssignFieldINT		(dbHandle, fieldName$, fieldNumber, fieldShort%)
DECLARE FUNCTION  xdbAssignFieldLNG		(dbHandle, fieldName$, fieldNumber, fieldLong&)
DECLARE FUNCTION  xdbAssignFieldSNG		(dbHandle, fieldName$, fieldNumber, SINGLE fieldSingle)
DECLARE FUNCTION  xdbAssignFieldDBL		(dbHandle, fieldName$, fieldNumber, fieldDouble#)
DECLARE FUNCTION  xdbAssignFieldCUR		(dbHandle, fieldName$, fieldNumber, fieldCurrency$$)

' DATABASE ROUTINES - Retrieving Field Values
DECLARE FUNCTION  xdbFieldValue$					(dbHandle, fieldName$, fieldCode)
DECLARE FUNCTION  SSHORT xdbFieldValueINT	(dbHandle, fieldName$, fieldCode)
DECLARE FUNCTION  SLONG	 xdbFieldValueLNG	(dbHandle, fieldName$, fieldCode)
DECLARE FUNCTION  SINGLE xdbFieldValueSNG	(dbHandle, fieldName$, fieldCode)
DECLARE FUNCTION  DOUBLE xdbFieldValueDBL	(dbHandle, fieldName$, fieldCode)
DECLARE FUNCTION  GIANT	 xdbFieldValueCUR	(dbHandle, fieldName$, fieldCode)

' INDEX ROUTINES - Creation/Opening/Closing
DECLARE FUNCTION  xdbCreateIndex			(iFilename$, dbHandle, indexExpression$, duplicates)
DECLARE FUNCTION  xdbOpenIndex				(iFilename$, dbHandle)
DECLARE FUNCTION  xdbCloseIndex				(dbHandle, idxHandle)
DECLARE FUNCTION  xdbCloseAllIndexes 	(dbHandle)
DECLARE FUNCTION  xdbReindex					(dbHandle, idxHandle)
DECLARE FUNCTION  xdbReindexAll				(dbHandle)
DECLARE FUNCTION  xdbSeek							(dbHandle, idxHandle, lookForKey$)
DECLARE FUNCTION  xdbSeekNext					(dbHandle, idxHandle, lookForKey$)
DECLARE FUNCTION  xdbSeekPartial      (dbHandle, idxHandle, partialKeyToLookFor$)
DECLARE FUNCTION  xdbSeekPartialNext  (dbHandle, idxHandle, partialKeyToLookFor$)
DECLARE FUNCTION  xdbSetCallback			(hWnd)

' INDEX ROUTINES - Index information
DECLARE FUNCTION  xdbKeyLength				(dbHandle, idxHandle)
DECLARE FUNCTION  xdbKeyCount					(dbHandle, idxHandle)
DECLARE FUNCTION  xdbKeyUnique				(dbHandle, idxHandle)
DECLARE FUNCTION  xdbKeyExpression$		(dbHandle, idxHandle)
DECLARE FUNCTION  xdbKeyPosition 			(idxHandle, KeyPosition)

' QUERY ROUTINES
DECLARE FUNCTION  xdbCreateQuery			(dbHandle)
DECLARE FUNCTION  xdbQueryCondition		(queryHandle, joinPhrase, fieldName$, equality, vParameter1$, vParameter2$)
DECLARE FUNCTION  xdbQuerySort				(queryHandle, fieldName$, sortDirection)
DECLARE FUNCTION  xdbQueryExecute			(queryHandle)
DECLARE FUNCTION  DOUBLE xdbQuerySUM	(queryHandle, fieldName$)
DECLARE FUNCTION  DOUBLE xdbQueryMIN	(queryHandle, fieldName$)
DECLARE FUNCTION  DOUBLE xdbQueryMAX	(queryHandle, fieldName$)
DECLARE FUNCTION  DOUBLE xdbQueryAVG	(queryHandle, fieldName$)
DECLARE FUNCTION  xdbDestroyQuery			(queryHandle)
DECLARE FUNCTION  xdbQueryIndex				(queryHandle)
DECLARE FUNCTION  xdbQueryDistinct 		(queryHandle, fieldName$)

' MISCELLANEOUS ROUTINES
DECLARE FUNCTION  xdbResetError				()
DECLARE FUNCTION  xdbError						()
DECLARE FUNCTION  xdbTempFileName$ 		()
DECLARE FUNCTION  xdbVersion$					()
DECLARE FUNCTION  xdbRegisteredTo$		()
DECLARE FUNCTION  xdbDebugMode				(userMode)
DECLARE FUNCTION  xdbAppPath$					()
DECLARE FUNCTION  xdbActivate					(code)

' DATE ROUTINES
DECLARE FUNCTION  xdbAddDate$ 				(StartDate$, NumDays)
DECLARE FUNCTION  xdbDateToJulian 		(DateString$)
DECLARE FUNCTION  xdbDaysApart 				(DateFrom$, DateTo$)
DECLARE FUNCTION  xdbDaysInMonth 			(Year, Month)
DECLARE FUNCTION  xdbJulianToDate$ 		(JulianNumber)
DECLARE FUNCTION  xdbNameOfDay$ 			(DateCheck$)
DECLARE FUNCTION  xdbTodaysDate$ 			()
DECLARE FUNCTION  xdbValidDate 				(DateCheck$)

' ENCRYPTION, FILELOCK, MULTITUSER ROUTINES
DECLARE FUNCTION  xdbEncryptionMethod (dbHandle)
DECLARE FUNCTION  xdbFailedLockInfo 	(dbHandle, @Reason$, @Username$, @Workstation$, @LockDate$, @LockTime$)
DECLARE FUNCTION  xdbIsEditLock 			(dbHandle, recordNumber)
DECLARE FUNCTION  xdbIsEncrypted 			(dbHandle)
DECLARE FUNCTION  xdbMultiUser 				(TrueFalse, NumRetries, WaitTime)
DECLARE FUNCTION  xdbRemoveEditLock 	(dbHandle, LOCK_NUM)
DECLARE FUNCTION  xdbSetEditLock 			(dbHandle,  recordNumber)
DECLARE FUNCTION  xdbRemoveExclusiveLock (dbHandle, LOCK_NUM)
DECLARE FUNCTION  xdbSetExclusiveLock (dbHandle)

' EQUATES - General and Error Codes
$$XDBTRUE 							= 1
$$XDBFALSE						  = 0

$$MAX_INDEXES           = 100
$$MAX_FIELDS            = 1000
$$MAX_CONDITIONS        = 50
$$MAX_INDEXKEYS         = 6
$$MAX_CHARFIELD_SIZE    = 256
$$MAX_NUMFIELD_SIZE     = 20

$$QUERY_AND							= 1
$$QUERY_OR 							= 2

$$EQUAL_TO 							= 1
$$NOT_EQUAL_TO 					= 2
$$LESS_THAN 						= 3
$$GREATER_THAN 					= 4
$$LESS_THAN_EQUAL_TO 		= 5
$$GREATER_THAN_EQUAL_TO	= 6
$$CONTAINS 							= 7
$$BETWEEN 							= 8
$$SUM 									= 9
$$MINIMUM 							= 10
$$MAXIMUM 							= 11
$$AVERAGE 							= 12
$$WILDCARD              = 13
$$SORT_ASCEND           = 1
$$SORT_DESCEND          = 0

$$XDBREADONLY 					= 0
$$XDBWRITEONLY 					= 1
$$XDBREADWRITE 					= 2

$$XDBDENYREADWRITE			= 1
$$XDBDENYWRITE 					= 2
$$XDBDENYREAD 					= 3
$$XDBDENYNONE 					= 4

$$XDBUNIQUE_CONTINUE    = 0
$$XDBUNIQUE_ERROR       = 1

$$FILE_ACCESS_ERROR 						= 4000
$$INVALID_DATE_FORMAT           = 4001
$$FILE_READ_ONLY                = 4002
$$FILE_WRITE_ONLY               = 4003
$$INVALID_FILENAME              = 4004
$$ENGINE_NOT_INITIALIZED 				= 5000
$$FILE_NOT_FOUND 								= 5001
$$TOO_MANY_FILES_OPEN 					= 5002
$$INVALID_STRUCTURE 						= 5003
$$FILE_NOT_OPEN 								= 5004
$$RECORD_OUT_OF_RANGE 					= 5005
$$FIELD_NOT_FOUND 							= 5006
$$INVALID_FILE_HANDLE 					= 5007
$$INVALID_FIELD_LENGTH 					= 5008
$$DUPLICATE_ALIAS_NAME 					= 5009
$$INVALID_ACCESSMODE 						= 5010
$$INVALID_SHAREMODE 						= 5011
$$RECORD_BUSY 									= 5012
$$INCOMPATIBLE_MEMO_FIELDS      = 5013
$$RECORDSIZE_EXCEEDED           = 5014
$$INVALID_ENCRYPTIONKEY         = 5015
$$DATABASE_NOT_OPEN 						= 7000
$$TOO_MANY_INDEXES_OPEN 				= 7002
$$INVALID_KEY_EXPRESSION 				= 7003
$$INDEX_NOT_OPEN 								= 7004
$$INDEX_UNIQUE_KEYS_ONLY 				= 7005
$$SEEK_NO_INDEX_SET 						= 7006
$$INDEX_NOT_FOUND               = 7007
$$QUERY_NOT_GENERATED 					= 9000
$$QUERY_INVALID_FIELDNAME				= 9001
$$QUERY_INVALID_COMPARISON 			= 9002
$$QUERY_MISSING_DELIMITERS 			= 9003
$$QUERY_MISSING_SEARCHSTRING 		= 9004
$$QUERY_TOO_MANY_EXPRESSIONS 		= 9005
$$QUERY_EXPECTED_NUMERIC_STRING	= 9006
$$QUERY_ERROR_GETRECORD 				= 9007
$$QUERY_INVALID_HANDLE 					= 9008
$$QUERY_INVALID_JOINPHRASE 			= 9009
$$QUERY_NO_WILDCARD_FOUND       = 9010
$$QUERY_INVALID_PARENTHESIS     = 9011
$$DLL_EXPIRED 									= 99999

$$ENCRYPT_NONE          = 0
$$ENCRYPT_RC4           = 1
$$ENCRYPT_KEYEDXOR      = 2
$$ENCRYPT_SUPERSCRAMBLE = 3
$$ENCRYPT_RIJNDAEL      = 4

END EXPORT
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  InitXCheetah ()
SHARED FUNCADDR XDBOPEN							(XLONG)
SHARED FUNCADDR XDBOPENEX						(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBALIAS						(XLONG)
SHARED FUNCADDR XDBSETALIAS					(XLONG, XLONG)
SHARED FUNCADDR XDBCREATEFIELDS			(XLONG)
SHARED FUNCADDR XDBADDFIELD					(XLONG)
SHARED FUNCADDR XDBCLOSE						(XLONG)
SHARED FUNCADDR XDBADDRECORD				(XLONG)
SHARED FUNCADDR XDBAPPENDRECORD			(XLONG)
SHARED FUNCADDR XDBCLEARBUFFER			(XLONG)
SHARED FUNCADDR XDBPUTRECORD				(XLONG, XLONG)
SHARED FUNCADDR XDBGETRECORD				(XLONG, XLONG)
SHARED FUNCADDR XDBDELETERECORD			(XLONG, XLONG)
SHARED FUNCADDR XDBRECALLRECORD			(XLONG, XLONG)
SHARED FUNCADDR XDBDELETED					(XLONG, XLONG)
SHARED FUNCADDR XDBFLUSHDATABASE		(XLONG)
SHARED FUNCADDR XDBPACK							(XLONG)
SHARED FUNCADDR XDBZAP							(XLONG)
SHARED FUNCADDR XDBRECORDBUFFER			(XLONG)
SHARED FUNCADDR XDBSPEEDAPPEND			(XLONG, XLONG)
SHARED FUNCADDR XDBRECORDCOUNT			(XLONG)
SHARED FUNCADDR XDBFIELDCOUNT				(XLONG)
SHARED FUNCADDR XDBFIELDNUMBER			(XLONG, XLONG)
SHARED FUNCADDR XDBRECORDNUMBER			(XLONG)
SHARED FUNCADDR XDBLASTUPDATED			(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBFIELDINFO				(XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBFIELDNAME				(XLONG, XLONG)
SHARED FUNCADDR XDBFIELDTYPE				(XLONG, XLONG)
SHARED FUNCADDR XDBFIELDLENGTH			(XLONG, XLONG)
SHARED FUNCADDR XDBFIELDDECIMALS		(XLONG, XLONG)
SHARED FUNCADDR XDBEOF							(XLONG)
SHARED FUNCADDR XDBBOF							(XLONG)
SHARED FUNCADDR XDBMOVEFIRST				(XLONG, XLONG)
SHARED FUNCADDR XDBMOVENEXT					(XLONG, XLONG)
SHARED FUNCADDR XDBMOVELAST					(XLONG, XLONG)
SHARED FUNCADDR XDBMOVEPREV					(XLONG, XLONG)
SHARED FUNCADDR XDBSKIPDELETED			(XLONG, XLONG)
SHARED FUNCADDR XDBASSIGNFIELD			(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBASSIGNFIELDINT		(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBASSIGNFIELDLNG		(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBASSIGNFIELDSNG		(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBASSIGNFIELDDBL		(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBASSIGNFIELDCUR		(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBFIELDVALUE				(XLONG, XLONG, XLONG)
SHARED FUNCADDR SSHORT XDBFIELDVALUEINT	(XLONG, XLONG, XLONG)
SHARED FUNCADDR SLONG	 XDBFIELDVALUELNG	(XLONG, XLONG, XLONG)
SHARED FUNCADDR SINGLE XDBFIELDVALUESNG	(XLONG, XLONG, XLONG)
SHARED FUNCADDR DOUBLE XDBFIELDVALUEDBL	(XLONG, XLONG, XLONG)
SHARED FUNCADDR GIANT	 XDBFIELDVALUECUR	(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBCREATEINDEX			(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBOPENINDEX				(XLONG, XLONG)
SHARED FUNCADDR XDBCLOSEINDEX				(XLONG, XLONG)
SHARED FUNCADDR XDBREINDEX					(XLONG, XLONG)
SHARED FUNCADDR XDBREINDEXALL				(XLONG)
SHARED FUNCADDR XDBSEEK							(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBSEEKPARTIAL			(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBSEEKPARTIALNEXT	(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBSEEKNEXT					(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBSETCALLBACK			(XLONG)
SHARED FUNCADDR XDBKEYLENGTH				(XLONG, XLONG)
SHARED FUNCADDR XDBKEYCOUNT					(XLONG, XLONG)
SHARED FUNCADDR XDBKEYUNIQUE				(XLONG, XLONG)
SHARED FUNCADDR XDBKEYEXPRESSION		(XLONG, XLONG)
SHARED FUNCADDR XDBCREATEQUERY			(XLONG)
SHARED FUNCADDR XDBQUERYCONDITION		(XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBQUERYSORT				(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBQUERYEXECUTE			(XLONG)
SHARED FUNCADDR DOUBLE XDBQUERYSUM	(XLONG, XLONG)
SHARED FUNCADDR DOUBLE XDBQUERYMIN	(XLONG, XLONG)
SHARED FUNCADDR DOUBLE XDBQUERYMAX	(XLONG, XLONG)
SHARED FUNCADDR DOUBLE XDBQUERYAVG	(XLONG, XLONG)
SHARED FUNCADDR XDBDESTROYQUERY			(XLONG)
SHARED FUNCADDR XDBQUERYINDEX				(XLONG)
SHARED FUNCADDR XDBRESETERROR				()
SHARED FUNCADDR XDBERROR						()
SHARED FUNCADDR XDBVERSION					()
SHARED FUNCADDR XDBREGISTEREDTO			()
SHARED FUNCADDR XDBDEBUGMODE				(XLONG)
SHARED FUNCADDR XDBAPPPATH					()
SHARED FUNCADDR XDBACTIVATE					(XLONG)


SHARED FUNCADDR XDBADDDATE					(XLONG, XLONG)
SHARED FUNCADDR XDBCLOSEALLINDEXES	(XLONG)
SHARED FUNCADDR XDBCREATEEXTENDED		(XLONG, XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBCREATEFIELDSEXTENDED	(XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBDATABASEHANDLES	(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBDATETOJULIAN			(XLONG)
SHARED FUNCADDR XDBDAYSAPART				(XLONG, XLONG)
SHARED FUNCADDR XDBDAYSINMONTH			(XLONG, XLONG)
SHARED FUNCADDR XDBENCRYPTIONMETHOD	(XLONG)
SHARED FUNCADDR XDBFAILEDLOCKINFO		(XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBFIELDPADDING			(XLONG, XLONG)
SHARED FUNCADDR XDBINDEXHANDLES			(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBISEDITLOCK				(XLONG, XLONG)
SHARED FUNCADDR XDBISENCRYPTED			(XLONG)
SHARED FUNCADDR XDBJULIANTODATE			(XLONG)
SHARED FUNCADDR XDBKEYPOSITION			(XLONG, XLONG)
SHARED FUNCADDR XDBMULTIUSER				(XLONG, XLONG, XLONG)
SHARED FUNCADDR XDBNAMEOFDAY				(XLONG)
SHARED FUNCADDR XDBQUERYDISTINCT		(XLONG, XLONG)
SHARED FUNCADDR XDBREMOVEEDITLOCK		(XLONG, XLONG)
SHARED FUNCADDR XDBREMOVEEXCLUSIVELOCK	(XLONG, XLONG)
SHARED FUNCADDR XDBSETEDITLOCK			(XLONG, XLONG)
SHARED FUNCADDR XDBSETEXCLUSIVELOCK	(XLONG)
SHARED FUNCADDR XDBTEMPFILENAME			()
SHARED FUNCADDR XDBTODAYSDATE				()
SHARED FUNCADDR XDBVALIDDATE				(XLONG)

	IF #initialized THEN RETURN
	#initialized = $$TRUE

	hLib = LoadLibraryA (&"cheetah2.dll")

	IFZ hLib THEN RETURN

	XDBOPEN							= GetProcAddress (hLib, &"XDBOPEN")
	XDBOPENEX						= GetProcAddress (hLib, &"XDBOPENEX")
	XDBALIAS						= GetProcAddress (hLib, &"XDBALIAS")
	XDBSETALIAS					= GetProcAddress (hLib, &"XDBSETALIAS")
	XDBCREATEFIELDS			= GetProcAddress (hLib, &"XDBCREATEFIELDS")
	XDBADDFIELD					= GetProcAddress (hLib, &"XDBADDFIELD")
	XDBCLOSE						= GetProcAddress (hLib, &"XDBCLOSE")
	XDBADDRECORD				= GetProcAddress (hLib, &"XDBADDRECORD")
	XDBAPPENDRECORD			= GetProcAddress (hLib, &"XDBAPPENDRECORD")
	XDBCLEARBUFFER			= GetProcAddress (hLib, &"XDBCLEARBUFFER")
	XDBPUTRECORD				= GetProcAddress (hLib, &"XDBPUTRECORD")
	XDBGETRECORD				= GetProcAddress (hLib, &"XDBGETRECORD")
	XDBDELETERECORD			= GetProcAddress (hLib, &"XDBDELETERECORD")
	XDBRECALLRECORD			= GetProcAddress (hLib, &"XDBRECALLRECORD")
	XDBDELETED					= GetProcAddress (hLib, &"XDBDELETED")
	XDBFLUSHDATABASE		= GetProcAddress (hLib, &"XDBFLUSHDATABASE")
	XDBPACK							= GetProcAddress (hLib, &"XDBPACK")
	XDBZAP							= GetProcAddress (hLib, &"XDBZAP")
	XDBRECORDBUFFER			= GetProcAddress (hLib, &"XDBRECORDBUFFER")
	XDBSPEEDAPPEND			= GetProcAddress (hLib, &"XDBSPEEDAPPEND")
	XDBRECORDCOUNT			= GetProcAddress (hLib, &"XDBRECORDCOUNT")
	XDBFIELDCOUNT				= GetProcAddress (hLib, &"XDBFIELDCOUNT")
	XDBFIELDNUMBER			= GetProcAddress (hLib, &"XDBFIELDNUMBER")
	XDBRECORDNUMBER			= GetProcAddress (hLib, &"XDBRECORDNUMBER")
	XDBLASTUPDATED			= GetProcAddress (hLib, &"XDBLASTUPDATED")
	XDBFIELDINFO				= GetProcAddress (hLib, &"XDBFIELDINFO")
	XDBFIELDNAME				= GetProcAddress (hLib, &"XDBFIELDNAME")
	XDBFIELDTYPE				= GetProcAddress (hLib, &"XDBFIELDTYPE")
	XDBFIELDLENGTH			= GetProcAddress (hLib, &"XDBFIELDLENGTH")
	XDBFIELDDECIMALS		= GetProcAddress (hLib, &"XDBFIELDDECIMALS")
	XDBEOF							= GetProcAddress (hLib, &"XDBEOF")
	XDBBOF							= GetProcAddress (hLib, &"XDBBOF")
	XDBMOVEFIRST				= GetProcAddress (hLib, &"XDBMOVEFIRST")
	XDBMOVENEXT					= GetProcAddress (hLib, &"XDBMOVENEXT")
	XDBMOVELAST					= GetProcAddress (hLib, &"XDBMOVELAST")
	XDBMOVEPREV					= GetProcAddress (hLib, &"XDBMOVEPREV")
	XDBSKIPDELETED			= GetProcAddress (hLib, &"XDBSKIPDELETED")
	XDBASSIGNFIELD			= GetProcAddress (hLib, &"XDBASSIGNFIELD")
	XDBASSIGNFIELDINT		= GetProcAddress (hLib, &"XDBASSIGNFIELDINT")
	XDBASSIGNFIELDLNG		= GetProcAddress (hLib, &"XDBASSIGNFIELDLNG")
	XDBASSIGNFIELDSNG		= GetProcAddress (hLib, &"XDBASSIGNFIELDSNG")
	XDBASSIGNFIELDDBL		= GetProcAddress (hLib, &"XDBASSIGNFIELDDBL")
	XDBASSIGNFIELDCUR		= GetProcAddress (hLib, &"XDBASSIGNFIELDCUR")
	XDBFIELDVALUE				= GetProcAddress (hLib, &"XDBFIELDVALUE")
	XDBFIELDVALUEINT		= GetProcAddress (hLib, &"XDBFIELDVALUEINT")
	XDBFIELDVALUELNG		= GetProcAddress (hLib, &"XDBFIELDVALUELNG")
	XDBFIELDVALUESNG		= GetProcAddress (hLib, &"XDBFIELDVALUESNG")
	XDBFIELDVALUEDBL		= GetProcAddress (hLib, &"XDBFIELDVALUEDBL")
	XDBFIELDVALUECUR		= GetProcAddress (hLib, &"XDBFIELDVALUECUR")
	XDBCREATEINDEX			= GetProcAddress (hLib, &"XDBCREATEINDEX")
	XDBOPENINDEX				= GetProcAddress (hLib, &"XDBOPENINDEX")
	XDBCLOSEINDEX				= GetProcAddress (hLib, &"XDBCLOSEINDEX")
	XDBREINDEX					= GetProcAddress (hLib, &"XDBREINDEX")
	XDBREINDEXALL				= GetProcAddress (hLib, &"XDBREINDEXALL")
	XDBSEEK							= GetProcAddress (hLib, &"XDBSEEK")
	XDBSEEKPARTIAL			= GetProcAddress (hLib, &"XDBSEEKPARTIAL")
	XDBSEEKNEXT					= GetProcAddress (hLib, &"XDBSEEKNEXT")
	XDBSEEKPARTIALNEXT	= GetProcAddress (hLib, &"XDBSEEKPARTIALNEXT")
	XDBSETCALLBACK			= GetProcAddress (hLib, &"XDBSETCALLBACK")
	XDBKEYLENGTH				= GetProcAddress (hLib, &"XDBKEYLENGTH")
	XDBKEYCOUNT					= GetProcAddress (hLib, &"XDBKEYCOUNT")
	XDBKEYUNIQUE				= GetProcAddress (hLib, &"XDBKEYUNIQUE")
	XDBKEYEXPRESSION		= GetProcAddress (hLib, &"XDBKEYEXPRESSION")
	XDBCREATEQUERY			= GetProcAddress (hLib, &"XDBCREATEQUERY")
	XDBQUERYCONDITION		= GetProcAddress (hLib, &"XDBQUERYCONDITION")
	XDBQUERYSORT				= GetProcAddress (hLib, &"XDBQUERYSORT")
	XDBQUERYEXECUTE			= GetProcAddress (hLib, &"XDBQUERYEXECUTE")
	XDBQUERYSUM					= GetProcAddress (hLib, &"XDBQUERYSUM")
	XDBQUERYMIN					= GetProcAddress (hLib, &"XDBQUERYMIN")
	XDBQUERYMAX					= GetProcAddress (hLib, &"XDBQUERYMAX")
	XDBQUERYAVG					= GetProcAddress (hLib, &"XDBQUERYAVG")
	XDBDESTROYQUERY			= GetProcAddress (hLib, &"XDBDESTROYQUERY")
	XDBQUERYINDEX				= GetProcAddress (hLib, &"XDBQUERYINDEX")
	XDBRESETERROR				= GetProcAddress (hLib, &"XDBRESETERROR")
	XDBERROR						= GetProcAddress (hLib, &"XDBERROR")
	XDBVERSION					= GetProcAddress (hLib, &"XDBVERSION")
	XDBREGISTEREDTO			= GetProcAddress (hLib, &"XDBREGISTEREDTO")
	XDBDEBUGMODE				= GetProcAddress (hLib, &"XDBDEBUGMODE")
	XDBAPPPATH					= GetProcAddress (hLib, &"XDBAPPPATH")
	XDBACTIVATE					= GetProcAddress (hLib, &"XDBACTIVATE")

	XDBADDDATE					= GetProcAddress (hLib, &"XDBADDDATE")
	XDBCLOSEALLINDEXES	= GetProcAddress (hLib, &"XDBCLOSEALLINDEXES")
	XDBCREATEFIELDSEXTENDED	= GetProcAddress (hLib, &"XDBCREATEFIELDSEXTENDED")
	XDBDATABASEHANDLES	= GetProcAddress (hLib, &"XDBDATABASEHANDLES")
	XDBDATETOJULIAN			= GetProcAddress (hLib, &"XDBDATETOJULIAN")
	XDBDAYSAPART				= GetProcAddress (hLib, &"XDBDAYSAPART")
	XDBDAYSINMONTH			= GetProcAddress (hLib, &"XDBDAYSINMONTH")
	XDBENCRYPTIONMETHOD	= GetProcAddress (hLib, &"XDBENCRYPTIONMETHOD")
	XDBFAILEDLOCKINFO		= GetProcAddress (hLib, &"XDBFAILEDLOCKINFO")
	XDBFIELDPADDING			= GetProcAddress (hLib, &"XDBFIELDPADDING")
	XDBINDEXHANDLES			= GetProcAddress (hLib, &"XDBINDEXHANDLES")
	XDBISEDITLOCK				= GetProcAddress (hLib, &"XDBISEDITLOCK")
	XDBISENCRYPTED			= GetProcAddress (hLib, &"XDBISENCRYPTED")
	XDBJULIANTODATE			= GetProcAddress (hLib, &"XDBJULIANTODATE")
	XDBKEYPOSITION			= GetProcAddress (hLib, &"XDBKEYPOSITION")
	XDBMULTIUSER				= GetProcAddress (hLib, &"XDBMULTIUSER")
	XDBNAMEOFDAY				= GetProcAddress (hLib, &"XDBNAMEOFDAY")
	XDBQUERYDISTINCT		= GetProcAddress (hLib, &"XDBQUERYDISTINCT")
	XDBREMOVEEDITLOCK		= GetProcAddress (hLib, &"XDBREMOVEEDITLOCK")
	XDBREMOVEEXCLUSIVELOCK	= GetProcAddress (hLib, &"XDBREMOVEEXCLUSIVELOCK")
	XDBSETEDITLOCK			= GetProcAddress (hLib, &"XDBSETEDITLOCK")
	XDBSETEXCLUSIVELOCK	= GetProcAddress (hLib, &"XDBSETEXCLUSIVELOCK")
	XDBTEMPFILENAME			= GetProcAddress (hLib, &"XDBTEMPFILENAME")
	XDBTODAYSDATE				= GetProcAddress (hLib, &"XDBTODAYSDATE")
	XDBVALIDDATE				= GetProcAddress (hLib, &"XDBVALIDDATE")

'	INLINE$ ("press any key")

END FUNCTION
'
'
' ###########################
' #####  AddHeader$ ()  #####
' ###########################
'
' Adds a 4-byte length header to a string
'
FUNCTION  AddHeader$ (s$)

	len = LEN(s$)
	t$ = NULL$(4) + s$
	ULONGAT(&t$) = len
	RETURN t$

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
' intercepts $$WM_SETTEXT messages from xdbSetCallback(), sends them to user window
'
FUNCTION  WndProc (hWnd, uMsg, wParam, lParam)

'	IF uMsg == $$WM_SETTEXT THEN
'		IF (hWnd == #hWnd) THEN
'			XgrSendMessage (#window, #WindowSystemMessage, hWnd, uMsg, wParam, lParam, 0, #window)
'			RETURN
'		END IF
'	END IF

'	IF #oldProc THEN
'		ret = CallWindowProcA(#oldProc, hWnd, uMsg, wParam, lParam)
'		RETURN ret
'	END IF

END FUNCTION
'
'
' ##########################
' #####  xdbCreate ()  #####
' ##########################
'
FUNCTION  xdbCreate (dbFile$, fieldArray$[])
	SHARED FUNCADDR XDBADDFIELD (XLONG)
	SHARED FUNCADDR XDBCREATEFIELDS (XLONG)

	IFZ #initialized THEN InitXCheetah()

	FOR i = 0 TO UBOUND(fieldArray$[])
		field$ = AddHeader$ (fieldArray$[i])
		lpField =  &field$ + 4
		@XDBADDFIELD (&lpField)
	NEXT i

	name$ = AddHeader$ (dbFile$)
	lpName = &name$ + 4
	@XDBCREATEFIELDS (&lpName)

END FUNCTION
'
'
' ########################
' #####  xdbOpen ()  #####
' ########################
'
FUNCTION  xdbOpen (dbFile$)
	SHARED FUNCADDR XDBOPEN(XLONG)

	IFZ #initialized THEN InitXCheetah()

	file$ = AddHeader$ (dbFile$)
	lpName = &file$ + 4
	RETURN @XDBOPEN (&lpName)

END FUNCTION
'
'
' ##########################
' #####  xdbOpenEx ()  #####
' ##########################
'
FUNCTION  xdbOpenEx (dbFile$, accessMode, shareMode)
	SHARED FUNCADDR XDBOPENEX (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	file$ = AddHeader$ (dbFile$)
	lpName = &file$
	RETURN @XDBOPENEX (&lpName, accessMode, shareMode)

END FUNCTION
'
'
' ##########################
' #####  xdbAlias$ ()  #####
' ##########################
'
FUNCTION  xdbAlias$ (dbHandle)
	SHARED FUNCADDR XDBALIAS (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBALIAS (dbHandle))

END FUNCTION
'
'
' ############################
' #####  xdbSetAlias ()  #####
' ############################
'
FUNCTION  xdbSetAlias (dbHandle, alias$)
	SHARED FUNCADDR XDBSETALIAS (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (alias$)
	lpAlias = &name$ + 4
	@XDBSETALIAS (dbHandle, &lpAlias)

END FUNCTION
'
'
' ################################
' #####  xdbCreateFields ()  #####
' ################################
'
FUNCTION  xdbCreateFields (fileName$)
	SHARED FUNCADDR XDBCREATEFIELDS (XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fileName$)
	lpName = &name$ + 4
	@XDBCREATEFIELDS (&lpName)

END FUNCTION
'
'
' ############################
' #####  xdbAddField ()  #####
' ############################
'
FUNCTION  xdbAddField (fieldInfoString$)
	SHARED FUNCADDR XDBADDFIELD (XLONG)

	IFZ #initialized THEN InitXCheetah()

	s$ = AddHeader$ (fieldInfoString$)
	lpField = &s$ + 4
	@XDBADDFIELD (&lpField)

END FUNCTION
'
'
' #########################
' #####  xdbClose ()  #####
' #########################
'
FUNCTION  xdbClose (dbHandle)
	SHARED FUNCADDR XDBCLOSE (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBCLOSE (dbHandle)

END FUNCTION
'
'
' #############################
' #####  xdbAddRecord ()  #####
' #############################
'
FUNCTION  xdbAddRecord (dbHandle)
	SHARED FUNCADDR XDBADDRECORD (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBADDRECORD (dbHandle)

END FUNCTION
'
'
' ################################
' #####  xdbAppendRecord ()  #####
' ################################
'
FUNCTION  xdbAppendRecord (dbHandle)
	SHARED FUNCADDR XDBAPPENDRECORD (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBAPPENDRECORD (dbHandle)

END FUNCTION
'
'
' ###############################
' #####  xdbClearBuffer ()  #####
' ###############################
'
FUNCTION  xdbClearBuffer (dbHandle)
	SHARED FUNCADDR XDBCLEARBUFFER (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBCLEARBUFFER (dbHandle)

END FUNCTION
'
'
' #############################
' #####  xdbPutRecord ()  #####
' #############################
'
FUNCTION  xdbPutRecord (dbHandle, recordNumber)
	SHARED FUNCADDR XDBPUTRECORD (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBPUTRECORD (dbHandle, &recordNumber)

END FUNCTION
'
'
' #############################
' #####  xdbGetRecord ()  #####
' #############################
'
FUNCTION  xdbGetRecord (dbHandle, recordNumber)
	SHARED FUNCADDR XDBGETRECORD (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBGETRECORD (dbHandle, recordNumber)

END FUNCTION
'
'
' ################################
' #####  xdbDeleteRecord ()  #####
' ################################
'
FUNCTION  xdbDeleteRecord (dbHandle, recordNumber)
	SHARED FUNCADDR XDBDELETERECORD (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBDELETERECORD (dbHandle, recordNumber)

END FUNCTION
'
'
' ################################
' #####  xdbRecallRecord ()  #####
' ################################
'
FUNCTION  xdbRecallRecord (dbHandle, recordNumber)
	SHARED FUNCADDR XDBRECALLRECORD (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBRECALLRECORD (dbHandle, recordNumber)

END FUNCTION
'
'
' ###########################
' #####  xdbDeleted ()  #####
' ###########################
'
FUNCTION  xdbDeleted (dbHandle, recordNumber)
	SHARED FUNCADDR XDBDELETED (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBDELETED (dbHandle, recordNumber)

END FUNCTION
'
'
' #################################
' #####  xdbFlushDatabase ()  #####
' #################################
'
FUNCTION  xdbFlushDatabase (dbHandle)
	SHARED FUNCADDR XDBFLUSHDATABASE (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBFLUSHDATABASE (dbHandle)

END FUNCTION
'
'
' ########################
' #####  xdbPack ()  #####
' ########################
'
FUNCTION  xdbPack (dbHandle)
	SHARED FUNCADDR XDBPACK (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBPACK (dbHandle)

END FUNCTION
'
'
' #######################
' #####  xdbZap ()  #####
' #######################
'
FUNCTION  xdbZap (dbHandle)
	SHARED FUNCADDR XDBZAP (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBZAP (dbHandle)

END FUNCTION
'
'
' #################################
' #####  xdbRecordBuffer$ ()  #####
' #################################
'
FUNCTION  xdbRecordBuffer$ (dbHandle)
	SHARED FUNCADDR XDBRECORDBUFFER (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBRECORDBUFFER (dbHandle))

END FUNCTION
'
'
' ###############################
' #####  xdbSpeedAppend ()  #####
' ###############################
'
FUNCTION  xdbSpeedAppend (dbHandle, trueFalse)
	SHARED FUNCADDR XDBSPEEDAPPEND (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBSPEEDAPPEND (dbHandle, trueFalse)

END FUNCTION
'
'
' ###############################
' #####  xdbRecordCount ()  #####
' ###############################
'
FUNCTION  xdbRecordCount (dbHandle)
	SHARED FUNCADDR XDBRECORDCOUNT (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBRECORDCOUNT (dbHandle)

END FUNCTION
'
'
' ##############################
' #####  xdbFieldCount ()  #####
' ##############################
'
FUNCTION  xdbFieldCount (dbHandle)
	SHARED FUNCADDR XDBFIELDCOUNT (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBFIELDCOUNT (dbHandle)

END FUNCTION
'
'
' ###############################
' #####  xdbFieldNumber ()  #####
' ###############################
'
FUNCTION  xdbFieldNumber (dbHandle, fieldName$)
	SHARED FUNCADDR XDBFIELDNUMBER (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName =  &name$ + 4
	RETURN @XDBFIELDNUMBER (dbHandle, &lpName)

END FUNCTION
'
'
' ################################
' #####  xdbrecordNumber ()  #####
' ################################
'
FUNCTION  xdbRecordNumber (dbHandle)
	SHARED FUNCADDR XDBRECORDNUMBER (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBRECORDNUMBER (dbHandle)

END FUNCTION
'
'
' ###############################
' #####  xdbLastUpdated ()  #####
' ###############################
'
FUNCTION  xdbLastUpdated (dbHandle, yearNr, monthNr, dayNr)
	SHARED FUNCADDR XDBLASTUPDATED (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBLASTUPDATED (dbHandle, &yearNr, &monthNr, &dayNr)

END FUNCTION
'
'
' #############################
' #####  xdbFieldInfo ()  #####
' #############################
'
FUNCTION  xdbFieldInfo (dbHandle, fieldNumber, fieldName$, fieldType$, fieldLength, fieldDecimals)
	SHARED FUNCADDR XDBFIELDINFO (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBFIELDINFO (dbHandle, fieldNumber, &lpName, &lpType, &fieldLength, &fieldDecimals)
	fieldName$ = CSTRING$(lpName)
	fieldType$ = CSTRING$(lpType)

END FUNCTION
'
'
' ##############################
' #####  xdbfieldName$ ()  #####
' ##############################
'
FUNCTION  xdbFieldName$ (dbHandle, fieldNumber)
	SHARED FUNCADDR XDBFIELDNAME (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBFIELDNAME (dbHandle, fieldNumber))

END FUNCTION
'
'
' ##############################
' #####  xdbFieldType$ ()  #####
' ##############################
'
FUNCTION  xdbFieldType$ (dbHandle, fieldNumber)
	SHARED FUNCADDR XDBFIELDTYPE (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBFIELDTYPE (dbHandle, fieldNumber))

END FUNCTION
'
'
' ###############################
' #####  xdbFieldLength ()  #####
' ###############################
'
FUNCTION  xdbFieldLength (dbHandle, fieldNumber)
	SHARED FUNCADDR XDBFIELDLENGTH (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBFIELDLENGTH (dbHandle, fieldNumber)

END FUNCTION
'
'
' #################################
' #####  xdbFieldDecimals ()  #####
' #################################
'
FUNCTION  xdbFieldDecimals (dbHandle, fieldNumber)
	SHARED FUNCADDR XDBFIELDDECIMALS (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBFIELDDECIMALS (dbHandle, fieldNumber)

END FUNCTION
'
'
' #######################
' #####  xdbEOF ()  #####
' #######################
'
FUNCTION  xdbEOF (dbHandle)
	SHARED FUNCADDR XDBEOF (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBEOF (dbHandle)

END FUNCTION
'
'
' #######################
' #####  xdbBOF ()  #####
' #######################
'
FUNCTION  xdbBOF (dbHandle)
	SHARED FUNCADDR XDBBOF (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBBOF (dbHandle)

END FUNCTION
'
'
' #############################
' #####  xdbMoveFirst ()  #####
' #############################
'
FUNCTION  xdbMoveFirst (dbHandle, idxHandle)
	SHARED FUNCADDR XDBMOVEFIRST (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBMOVEFIRST (dbHandle, idxHandle)

END FUNCTION
'
'
' ############################
' #####  xdbMoveNext ()  #####
' ############################
'
FUNCTION  xdbMoveNext (dbHandle, idxHandle)
	SHARED FUNCADDR XDBMOVENEXT (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBMOVENEXT (dbHandle, idxHandle)

END FUNCTION
'
'
' ############################
' #####  xdbMoveLast ()  #####
' ############################
'
FUNCTION  xdbMoveLast (dbHandle, idxHandle)
	SHARED FUNCADDR XDBMOVELAST (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBMOVELAST (dbHandle, idxHandle)

END FUNCTION
'
'
' ############################
' #####  xdbMovePrev ()  #####
' ############################
'
FUNCTION  xdbMovePrev (dbHandle, idxHandle)
	SHARED FUNCADDR XDBMOVEPREV (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBMOVEPREV (dbHandle, idxHandle)

END FUNCTION
'
'
' ###############################
' #####  xdbSkipDeleted ()  #####
' ###############################
'
FUNCTION  xdbSkipDeleted (dbHandle, trueFalse)
	SHARED FUNCADDR XDBSKIPDELETED (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBSKIPDELETED (dbHandle, trueFalse)

END FUNCTION
'
'
' ###############################
' #####  xdbAssignField ()  #####
' ###############################
'
FUNCTION  xdbAssignField (dbHandle, fieldName$, fieldNumber, fieldString$)
	SHARED FUNCADDR XDBASSIGNFIELD (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	fName$ = AddHeader$ (fieldName$)
	lpName =  &fName$ + 4
	fString$ = AddHeader$ (fieldString$)
	lpString = &fString$ + 4
	@XDBASSIGNFIELD (dbHandle, &lpName, fieldNumber, &lpString)

END FUNCTION
'
'
' ##################################
' #####  xdbAssignFieldINT ()  #####
' ##################################
'
FUNCTION  xdbAssignFieldINT (dbHandle, fieldName$, fieldNumber, fieldShort%)
	SHARED FUNCADDR XDBASSIGNFIELDINT (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	fName$ = AddHeader$ (fieldName$)
	lpName = &fName$ + 4
	@XDBASSIGNFIELDINT (dbHandle, 	&lpName, fieldNumber, &fieldShort%)

END FUNCTION
'
'
' ##################################
' #####  xdbAssignFieldLNG ()  #####
' ##################################
'
FUNCTION  xdbAssignFieldLNG (dbHandle, fieldName$, fieldNumber, fieldLong&)
	SHARED FUNCADDR XDBASSIGNFIELDLNG (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	fName$ = AddHeader$ (fieldName$)
	lpName = &fName$ + 4
	@XDBASSIGNFIELDLNG (dbHandle, 	&lpName, fieldNumber, &fieldLong&)

END FUNCTION
'
'
' ##################################
' #####  xdbAssignFieldSNG ()  #####
' ##################################
'
FUNCTION  xdbAssignFieldSNG (dbHandle, fieldName$, fieldNumber, SINGLE fieldSingle)
	SHARED FUNCADDR XDBASSIGNFIELDSNG (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	fName$ = AddHeader$ (fieldName$)
	lpName = &fName$ + 4
	@XDBASSIGNFIELDSNG (dbHandle, &lpName, fieldNumber, &fieldSingle)

END FUNCTION
'
'
' ##################################
' #####  xdbAssignFieldDBL ()  #####
' ##################################
'
FUNCTION  xdbAssignFieldDBL (dbHandle, fieldName$, fieldNumber, fieldDouble#)
	SHARED FUNCADDR XDBASSIGNFIELDDBL (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	fName$ = AddHeader$ (fieldName$)
	lpName = &fName$ + 4
	@XDBASSIGNFIELDDBL (dbHandle, &lpName, fieldNumber, &fieldDouble#)

END FUNCTION
'
'
' ##################################
' #####  xdbAssignFieldCUR ()  #####
' ##################################
'
FUNCTION  xdbAssignFieldCUR (dbHandle, fieldName$, fieldNumber, fieldCurrency$$)
	SHARED FUNCADDR XDBASSIGNFIELDCUR (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	fName$ = AddHeader$ (fieldName$)
	lpName = &fName$ + 4
	@XDBASSIGNFIELDCUR (dbHandle, &lpName, fieldNumber, &fieldCurrency$$)

END FUNCTION
'
'
' ###############################
' #####  xdbFieldValue$ ()  #####
' ###############################
'
FUNCTION  xdbFieldValue$ (dbHandle, fieldName$, fieldCode)
	SHARED FUNCADDR XDBFIELDVALUE (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName =&name$ + 4
	RETURN CSTRING$(@XDBFIELDVALUE (dbHandle, &lpName, fieldCode))

END FUNCTION
'
'
' #################################
' #####  xdbFieldValueINT ()  #####
' #################################
'
FUNCTION SSHORT xdbFieldValueINT (dbHandle, fieldName$, fieldCode)
	SHARED FUNCADDR SSHORT XDBFIELDVALUEINT (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBFIELDVALUEINT (dbHandle, &lpName, fieldCode)

END FUNCTION
'
'
' #################################
' #####  xdbFieldValueLNG ()  #####
' #################################
'
FUNCTION  SLONG xdbFieldValueLNG (dbHandle, fieldName$, fieldCode)
	SHARED FUNCADDR SLONG	 XDBFIELDVALUELNG (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBFIELDVALUELNG (dbHandle, &lpName, fieldCode)

END FUNCTION
'
'
' #################################
' #####  xdbFieldValueSNG ()  #####
' #################################
'
FUNCTION  SINGLE xdbFieldValueSNG (dbHandle, fieldName$, fieldCode)
	SHARED FUNCADDR SINGLE XDBFIELDVALUESNG (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBFIELDVALUESNG (dbHandle, &lpName, fieldCode)

END FUNCTION
'
'
' #################################
' #####  xdbFieldValueDBL ()  #####
' #################################
'
FUNCTION  DOUBLE xdbFieldValueDBL (dbHandle, fieldName$, fieldCode)
	SHARED FUNCADDR DOUBLE XDBFIELDVALUEDBL (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBFIELDVALUEDBL (dbHandle, &lpName, fieldCode)

END FUNCTION
'
'
' #################################
' #####  xdbFieldValueCUR ()  #####
' #################################
'
FUNCTION  GIANT xdbFieldValueCUR (dbHandle, fieldName$, fieldCode)
	SHARED FUNCADDR GIANT	 XDBFIELDVALUECUR (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBFIELDVALUECUR (dbHandle, &lpName, fieldCode)

END FUNCTION
'
'
' ###############################
' #####  xdbCreateIndex ()  #####
' ###############################
'
FUNCTION  xdbCreateIndex (ifileName$, dbHandle, indexExpression$, duplicates)
	SHARED FUNCADDR XDBCREATEINDEX (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (ifileName$)
	lpName = &name$ + 4
	expr$ = AddHeader$ (indexExpression$)
	lpExpr = &expr$ + 4
	@XDBCREATEINDEX (&lpName, dbHandle, &lpExpr, duplicates)

END FUNCTION
'
'
' #############################
' #####  xdbOpenIndex ()  #####
' #############################
'
FUNCTION  xdbOpenIndex (ifileName$, dbHandle)
	SHARED FUNCADDR XDBOPENINDEX (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	file$ = AddHeader$ (ifileName$)
	lpName = &file$ + 4
	RETURN @XDBOPENINDEX (&lpName, dbHandle)

END FUNCTION
'
'
' ##############################
' #####  xdbCloseIndex ()  #####
' ##############################
'
FUNCTION  xdbCloseIndex (dbHandle, idxHandle)
	SHARED FUNCADDR XDBCLOSEINDEX (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBCLOSEINDEX (dbHandle, idxHandle)

END FUNCTION
'
'
' ###########################
' #####  xdbReindex ()  #####
' ###########################
'
FUNCTION  xdbReindex (dbHandle, idxHandle)
	SHARED FUNCADDR XDBREINDEX (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBREINDEX (dbHandle, idxHandle)

END FUNCTION
'
'
' ##############################
' #####  xdbReindexAll ()  #####
' ##############################
'
FUNCTION  xdbReindexAll (dbHandle)
	SHARED FUNCADDR XDBREINDEXALL (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBREINDEXALL (dbHandle)

END FUNCTION
'
'
' ########################
' #####  xdbSeek ()  #####
' ########################
'
FUNCTION  xdbSeek (dbHandle, idxHandle, lookForKey$)
	SHARED FUNCADDR XDBSEEK (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	key$ = AddHeader$ (lookForKey$)
	lpKey = &key$ + 4
	RETURN @XDBSEEK (dbHandle, idxHandle, &lpKey)

END FUNCTION
'
'
' ###############################
' #####  xdbSeekPartial ()  #####
' ###############################
'
FUNCTION  xdbSeekPartial (dbHandle, idxHandle, partialKeyToLookFor$)
	SHARED FUNCADDR XDBSEEKPARTIAL (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	key$ = AddHeader$ (partialKeyToLookFor$)
	lpKey = &key$ + 4
	RETURN @XDBSEEKPARTIAL (dbHandle, idxHandle, &lpKey)

END FUNCTION
'
'
' ############################
' #####  xdbSeekNext ()  #####
' ############################
'
FUNCTION  xdbSeekNext (dbHandle, idxHandle, lookForKey$)
	SHARED FUNCADDR XDBSEEKNEXT (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	key$ = AddHeader$ (lookForKey$)
	lpKey = &key$ + 4
	RETURN @XDBSEEKNEXT (dbHandle, idxHandle, &lpKey)

END FUNCTION
'
'
' ###################################
' #####  xdbSeekPartialNext ()  #####
' ###################################
'
FUNCTION  xdbSeekPartialNext (dbHandle, idxHandle, partialKeyToLookFor$)
	SHARED FUNCADDR XDBSEEKPARTIALNEXT (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	key$ = AddHeader$ (partialKeyToLookFor$)
	lpKey = &key$ + 4
	RETURN @XDBSEEKPARTIALNEXT (dbHandle, idxHandle, &lpKey)

END FUNCTION
'
'
' ###############################
' #####  xdbSetCallback ()  #####
' ###############################
'
FUNCTION  xdbSetCallback (hWnd)
	SHARED FUNCADDR XDBSETCALLBACK (XLONG)

	IFZ #initialized THEN InitXCheetah()

'	IF hWnd THEN
'			IF #hWnd THEN RETURN
'			XgrMessageNameToNumber ("WindowSystemMessage", @#WindowSystemMessage)
'			XgrSystemWindowToWindow (hWnd, @#window, 0)
'			#oldProc = SetWindowLongA (hWnd, $$GWL_WNDPROC, &WndProc())
'			#hWnd = hWnd
'		ELSE
'			IFZ #hWnd THEN RETURN
'			IF #oldProc THEN SetWindowLongA (#hWnd, $$GWL_WNDPROC, #oldProc)
'			#hWnd = 0
'			#window = 0
'			#oldProc = 0
'	END IF

	@XDBSETCALLBACK (hWnd)

END FUNCTION
'
'
' #############################
' #####  xdbKeyLength ()  #####
' #############################
'
FUNCTION  xdbKeyLength (dbHandle, idxHandle)
	SHARED FUNCADDR XDBKEYLENGTH (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBKEYLENGTH (dbHandle, idxHandle)

END FUNCTION
'
'
' ############################
' #####  xdbKeyCount ()  #####
' ############################
'
FUNCTION  xdbKeyCount (dbHandle, idxHandle)
	SHARED FUNCADDR XDBKEYCOUNT (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBKEYCOUNT (dbHandle, idxHandle)

END FUNCTION
'
'
' #############################
' #####  xdbKeyUnique ()  #####
' #############################
'
FUNCTION  xdbKeyUnique (dbHandle, idxHandle)
	SHARED FUNCADDR XDBKEYUNIQUE (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBKEYUNIQUE (dbHandle, idxHandle)

END FUNCTION
'
'
' ##################################
' #####  xdbKeyExpression$ ()  #####
' ##################################
'
FUNCTION  xdbKeyExpression$ (dbHandle, idxHandle)
	SHARED FUNCADDR XDBKEYEXPRESSION (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBKEYEXPRESSION (dbHandle, idxHandle))

END FUNCTION
'
'
' ###############################
' #####  xdbCreateQuery ()  #####
' ###############################
'
FUNCTION  xdbCreateQuery (dbHandle)
	SHARED FUNCADDR XDBCREATEQUERY (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBCREATEQUERY (dbHandle)

END FUNCTION
'
'
' ##################################
' #####  xdbQueryCondition ()  #####
' ##################################
'
FUNCTION  xdbQueryCondition (queryHandle, joinPhrase, fieldName$, equality, vParameter1$, vParameter2$)
	SHARED FUNCADDR XDBQUERYCONDITION (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	p1$ = AddHeader$ (vParameter1$)
	lpP1 = &p1$ + 4
	p2$ = AddHeader$ (vParameter2$)
	lpP2 = &p2$ + 4
	@XDBQUERYCONDITION (queryHandle, joinPhrase, &lpName, equality, &lpP1, &lpP2)

END FUNCTION
'
'
' #############################
' #####  xdbQuerySort ()  #####
' #############################
'
FUNCTION  xdbQuerySort (queryHandle, fieldName$, sortDirection)
	SHARED FUNCADDR XDBQUERYSORT (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	@XDBQUERYSORT (queryHandle, &lpName, sortDirection)

END FUNCTION
'
'
' ################################
' #####  xdbQueryExecute ()  #####
' ################################
'
FUNCTION  xdbQueryExecute (queryHandle)
	SHARED FUNCADDR XDBQUERYEXECUTE (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBQUERYEXECUTE (queryHandle)

END FUNCTION
'
'
' ############################
' #####  xdbQuerySUM ()  #####
' ############################
'
FUNCTION  DOUBLE xdbQuerySUM (queryHandle, fieldName$)
	SHARED FUNCADDR DOUBLE XDBQUERYSUM (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBQUERYSUM (queryHandle, &lpName)

END FUNCTION
'
'
' ############################
' #####  xdbQueryMIN ()  #####
' ############################
'
FUNCTION  DOUBLE xdbQueryMIN (queryHandle, fieldName$)
	SHARED FUNCADDR DOUBLE XDBQUERYMIN (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBQUERYMIN (queryHandle, &lpName)

END FUNCTION
'
'
' ############################
' #####  xdbQueryMAX ()  #####
' ############################
'
FUNCTION  DOUBLE xdbQueryMAX (queryHandle, fieldName$)
	SHARED FUNCADDR DOUBLE XDBQUERYMAX (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBQUERYMAX (queryHandle, &lpName)

END FUNCTION
'
'
' ############################
' #####  xdbQueryAVG ()  #####
' ############################
'
FUNCTION  DOUBLE xdbQueryAVG (queryHandle, fieldName$)
	SHARED FUNCADDR DOUBLE XDBQUERYAVG (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4
	RETURN @XDBQUERYAVG (queryHandle, &lpName)

END FUNCTION
'
'
' ################################
' #####  xdbDestroyQuery ()  #####
' ################################
'
FUNCTION  xdbDestroyQuery (queryHandle)
	SHARED FUNCADDR XDBDESTROYQUERY (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBDESTROYQUERY (queryHandle)

END FUNCTION
'
'
' ##############################
' #####  xdbQueryIndex ()  #####
' ##############################
'
FUNCTION  xdbQueryIndex (queryHandle)
	SHARED FUNCADDR XDBQUERYINDEX (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBQUERYINDEX (queryHandle)

END FUNCTION
'
'
' ##############################
' #####  xdbResetError ()  #####
' ##############################
'
FUNCTION  xdbResetError ()
	SHARED FUNCADDR XDBRESETERROR ()

	IFZ #initialized THEN InitXCheetah()

	@XDBRESETERROR ()

END FUNCTION
'
'
' #########################
' #####  xdbError ()  #####
' #########################
'
FUNCTION  xdbError ()
	SHARED FUNCADDR XDBERROR ()

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBERROR ()

END FUNCTION
'
'
' ############################
' #####  xdbVersion$ ()  #####
' ############################
'
FUNCTION  xdbVersion$ ()
	SHARED FUNCADDR XDBVERSION ()

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBVERSION ())

END FUNCTION
'
'
' #################################
' #####  xdbRegisteredTo$ ()  #####
' #################################
'
FUNCTION  xdbRegisteredTo$ ()
	SHARED FUNCADDR XDBREGISTEREDTO ()

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBREGISTEREDTO ())

END FUNCTION
'
'
' #############################
' #####  xdbDebugMode ()  #####
' #############################
'
FUNCTION  xdbDebugMode (userMode)
	SHARED FUNCADDR XDBDEBUGMODE (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBDEBUGMODE (userMode)

END FUNCTION
'
'
' ############################
' #####  xdbAppPath$ ()  #####
' ############################
'
FUNCTION  xdbAppPath$ ()
	SHARED FUNCADDR XDBAPPPATH ()

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBAPPPATH ())

END FUNCTION
'
'
' ############################
' #####  xdbActivate ()  #####
' ############################
'
FUNCTION  xdbActivate (code)
	SHARED FUNCADDR XDBACTIVATE (XLONG)

	IFZ #initialized THEN InitXCheetah()

	IF XDBACTIVATE THEN @XDBACTIVATE (code)

END FUNCTION
'
' ########################
' #####  xdbAddDate  #####
' ########################
'
'
'
FUNCTION xdbAddDate$ (StartDate$, NumDays)
	SHARED FUNCADDR XDBADDDATE (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	date$ = AddHeader$ (StartDate$)
	lpDate = &date$ + 4
	RETURN CSTRING$ (@XDBADDDATE (&lpDate, NumDays))

END FUNCTION
'
' ################################
' #####  xdbCloseAllIndexes  #####
' ################################
'
'
'
FUNCTION xdbCloseAllIndexes (dbHandle)
	SHARED FUNCADDR XDBCLOSEALLINDEXES (XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBCLOSEALLINDEXES (dbHandle)

END FUNCTION
'
' ###############################
' #####  xdbCreateExtended  #####
' ###############################
'
'
'
FUNCTION xdbCreateExtended (fileName$, fieldArray$[], MemoBlockSize, Algorithm, EncryptionKey$)
	SHARED FUNCADDR XDBADDFIELD (XLONG)
	SHARED FUNCADDR XDBCREATEFIELDSEXTENDED (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	FOR i = 0 TO UBOUND(fieldArray$[])
		field$ = AddHeader$ (fieldArray$[i])
		lpField =  &field$ + 4
		@XDBADDFIELD (&lpField)
	NEXT i

	key$ = AddHeader$ (EncryptionKey$)
	lpKey = &key$ + 4

	name$ = AddHeader$ (fileName$)
	lpName = &name$ + 4

	@XDBCREATEFIELDSEXTENDED (&lpName, MemoBlockSize, Algorithm, &lpKey)

END FUNCTION
'
' #####################################
' #####  xdbCreateFieldsExtended  #####
' #####################################
'
'
'
FUNCTION xdbCreateFieldsExtended (fileName$, MemoBlockSize, Algorithm, EncryptionKey$)
	SHARED FUNCADDR XDBCREATEFIELDSEXTENDED (XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fileName$)
	lpName = &name$ + 4

	key$ = AddHeader$ (EncryptionKey$)
	lpKey = &key$ + 4

	@XDBCREATEFIELDSEXTENDED (&lpName, MemoBlockSize, Algorithm, &lpKey)

END FUNCTION
'
' ################################
' #####  xdbDatabaseHandles  #####
' ################################
'
'
'
FUNCTION xdbDatabaseHandles (fileName$, CheetahHandle, WindowsHandle)
	SHARED FUNCADDR XDBDATABASEHANDLES (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	file$ = AddHeader$ (fileName$)
	lpFN = &file$ + 4

	@XDBDATABASEHANDLES (&lpFN, &CheetahHandle, &WindowsHandle)

END FUNCTION
'
' #############################
' #####  xdbDateToJulian  #####
' #############################
'
'
'
FUNCTION xdbDateToJulian (DateString$)
	SHARED FUNCADDR XDBDATETOJULIAN (XLONG)

	IFZ #initialized THEN InitXCheetah()

	ds$ = AddHeader$ (DateString$)
	lpDS = &ds$ + 4

	RETURN @XDBDATETOJULIAN (&lpDS)

END FUNCTION
'
' ##########################
' #####  xdbDaysApart  #####
' ##########################
'
'
'
FUNCTION xdbDaysApart (DateFrom$, DateTo$)
	SHARED FUNCADDR XDBDAYSAPART (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	df$ = AddHeader$ (DateFrom$)
	lpDF = &df$ + 4

	dt$ = AddHeader$ (DateTo$)
	lpDT = &dt$ + 4

	RETURN @XDBDAYSAPART (&lpDF, &lpDT)

END FUNCTION
'
' ############################
' #####  xdbDaysInMonth  #####
' ############################
'
'
'
FUNCTION xdbDaysInMonth (Year, Month)
	SHARED FUNCADDR XDBDAYSINMONTH (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBDAYSINMONTH (Year, Month)

END FUNCTION
'
' #################################
' #####  xdbEncryptionMethod  #####
' #################################
'
'
'
FUNCTION xdbEncryptionMethod (dbHandle)
	SHARED FUNCADDR XDBENCRYPTIONMETHOD (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBENCRYPTIONMETHOD (dbHandle)

END FUNCTION
'
' ###############################
' #####  xdbFailedLockInfo  #####
' ###############################
'
'
'
FUNCTION xdbFailedLockInfo (dbHandle, Reason$, Username$, Workstation$, LockDate$, LockTime$)
	SHARED FUNCADDR XDBFAILEDLOCKINFO (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBFAILEDLOCKINFO (dbHandle, &lpReason, &lpUser, &lpWork, &lpDate, &lpTime)
	Reason$ = CSTRING$(lpReason)
	Username$ = CSTRING$(lpUser)
	Workstation$ = CSTRING$(lpWork)
	LockDate$ = CSTRING$(lpDate)
	LockTime$ = CSTRING$(lpTime)

END FUNCTION
'
' #############################
' #####  xdbFieldPadding  #####
' #############################
'
'
'
FUNCTION xdbFieldPadding (dbHandle, TrueFalse)
	SHARED FUNCADDR XDBFIELDPADDING (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBFIELDPADDING (dbHandle, TrueFalse)

END FUNCTION
'
' #############################
' #####  xdbIndexHandles  #####
' #############################
'
'
'
FUNCTION xdbIndexHandles (iFileName$, CheetahHandle, WindowsHandle)
	SHARED FUNCADDR XDBINDEXHANDLES (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	fn$ = AddHeader$ (iFileName$)
	lpFN = &fn$ + 4

	@XDBINDEXHANDLES (&lpFN, &CheetahHandle, &WindowsHandle)

END FUNCTION
'
' ###########################
' #####  xdbIsEditLock  #####
' ###########################
'
'
'
FUNCTION xdbIsEditLock (dbHandle, recordNumber)
	SHARED FUNCADDR XDBISEDITLOCK (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBISEDITLOCK (dbHandle, recordNumber)

END FUNCTION
'
' ############################
' #####  xdbIsEncrypted  #####
' ############################
'
'
'
FUNCTION xdbIsEncrypted (dbHandle)
	SHARED FUNCADDR XDBISENCRYPTED (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBISENCRYPTED (dbHandle)

END FUNCTION
'
' #############################
' #####  xdbJulianToDate  #####
' #############################
'
'
'
FUNCTION xdbJulianToDate$ (JulianNumber)
	SHARED FUNCADDR XDBJULIANTODATE (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBJULIANTODATE(JulianNumber))

END FUNCTION
'
' ############################
' #####  xdbKeyPosition  #####
' ############################
'
'
'
FUNCTION xdbKeyPosition (idxHandle, KeyPosition)
	SHARED FUNCADDR XDBKEYPOSITION (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBKEYPOSITION (idxHandle, KeyPosition)

END FUNCTION
'
' ##########################
' #####  xdbMultiUser  #####
' ##########################
'
'
'
FUNCTION xdbMultiUser (TrueFalse, NumRetries, WaitTime)
	SHARED FUNCADDR XDBMULTIUSER (XLONG, XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBMULTIUSER (TrueFalse, NumRetries, WaitTime)

END FUNCTION
'
' ##########################
' #####  xdbNameOfDay  #####
' ##########################
'
'
'
FUNCTION xdbNameOfDay$ (DateCheck$)
	SHARED FUNCADDR XDBNAMEOFDAY (XLONG)

	IFZ #initialized THEN InitXCheetah()

	dc$ = AddHeader$ (DateCheck$)
	lpDC = &dc$ + 4

	RETURN CSTRING$(@XDBNAMEOFDAY (&lpDC))


END FUNCTION
'
' ##############################
' #####  xdbQueryDistinct  #####
' ##############################
'
'
'
FUNCTION xdbQueryDistinct (queryHandle, fieldName$)
	SHARED FUNCADDR XDBQUERYDISTINCT (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	name$ = AddHeader$ (fieldName$)
	lpName = &name$ + 4

	@XDBQUERYDISTINCT (queryHandle, &lpName)

END FUNCTION
'
' ###############################
' #####  xdbRemoveEditLock  #####
' ###############################
'
'
'
FUNCTION xdbRemoveEditLock (dbHandle, LOCK_NUM)
	SHARED FUNCADDR XDBREMOVEEDITLOCK (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBREMOVEEDITLOCK (dbHandle, LOCK_NUM)

END FUNCTION
'
' ############################
' #####  xdbSetEditLock  #####
' ############################
'
'
'
FUNCTION xdbSetEditLock (dbHandle, recordNumber)
	SHARED FUNCADDR XDBSETEDITLOCK (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBSETEDITLOCK (dbHandle, recordNumber)

END FUNCTION
'
' ####################################
' #####  xdbRemoveExclusiveLock  #####
' ####################################
'
'
'
FUNCTION xdbRemoveExclusiveLock (dbHandle, LOCK_NUM)
	SHARED FUNCADDR XDBREMOVEEXCLUSIVELOCK (XLONG, XLONG)

	IFZ #initialized THEN InitXCheetah()

	@XDBREMOVEEXCLUSIVELOCK (dbHandle, LOCK_NUM)

END FUNCTION
'
' #################################
' #####  xdbSetExclusiveLock  #####
' #################################
'
'
'
FUNCTION xdbSetExclusiveLock (dbHandle)
	SHARED FUNCADDR XDBSETEXCLUSIVELOCK (XLONG)

	IFZ #initialized THEN InitXCheetah()

	RETURN @XDBSETEXCLUSIVELOCK (dbHandle)

END FUNCTION
'
' #############################
' #####  xdbTempFileName  #####
' #############################
'
'
'
FUNCTION xdbTempFileName$ ()
	SHARED FUNCADDR XDBTEMPFILENAME ()

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBTEMPFILENAME ())

END FUNCTION
'
' ###########################
' #####  xdbTodaysDate  #####
' ###########################
'
'
'
FUNCTION xdbTodaysDate$ ()
	SHARED FUNCADDR XDBTODAYSDATE ()

	IFZ #initialized THEN InitXCheetah()

	RETURN CSTRING$(@XDBTODAYSDATE ())

END FUNCTION
'
' ##########################
' #####  xdbValidDate  #####
' ##########################
'
'
'
FUNCTION xdbValidDate (DateCheck$)
	SHARED FUNCADDR XDBVALIDDATE (XLONG)

	IFZ #initialized THEN InitXCheetah()

	dc$ = AddHeader$ (DateCheck$)
	lpDC = &dc$ + 4
	RETURN @XDBVALIDDATE (&lpDC)

END FUNCTION
END PROGRAM
