
' Demo to query existing database db3_eighties.dbf

VERSION "0.0001"
CONSOLE
'
	IMPORT "xst"
	IMPORT "xsx"
	IMPORT "xCheetah"

DECLARE FUNCTION Entry ()

FUNCTION Entry ()

	' define the names of the database
  DBFname$ = "db3_eighties.dbf"

	' open the database (database must be open prior to creating index)
  dbHandle = xdbOpen (DBFname$)
  IF xdbError() THEN
     XstAlert ("Error: " + STR$(xdbError()) + " opening database.")
     xdbResetError ()
     RETURN
  END IF

	' create a query handle
	hQuery1 = xdbCreateQuery(dbHandle)
  IF xdbError() THEN
     XstAlert ("Error: " + STR$(xdbError()) + " creating query.")
     xdbResetError ()
     RETURN
  END IF

	? "Query for ARTIST = Bruce Springsteen OR = Stevie Wonder"
	' specify conditions of query
	xdbQueryCondition(hQuery1, 0, "ARTIST", $$EQUAL_TO, "Bruce Springsteen", "")
	xdbQueryCondition(hQuery1, $$QUERY_OR, "ARTIST", $$EQUAL_TO, "Stevie Wonder", "")

	' execute the query
	xdbQueryExecute(hQuery1)

	' iterate through query results
	FOR x = 1 TO xdbRecordCount (hQuery1)
		xdbGetRecord (hQuery1, x)
		artist$ = xdbFieldValue$ (hQuery1, "ARTIST", 0)
		title$ = xdbFieldValue$ (hQuery1, "TITLE", 0)
		? artist$; ": "; title$
	NEXT
	?

	' destroy query
	xdbDestroyQuery (hQuery1)

	' try another query

		' create a query handle
	hQuery1 = xdbCreateQuery (dbHandle)
  IF xdbError() THEN
    XstAlert ("Error: " + STR$(xdbError()) + " creating query.")
    xdbResetError ()
    RETURN
  END IF

	' specify conditions of query
	? "Query for all YEAR BETWEEN 81 and 84"
	xdbQueryCondition(hQuery1, 0, "YEAR", $$BETWEEN, "81", "84")
	IF xdbError() THEN
    XstAlert ("Error: " + STR$(xdbError()) + " query condition.")
    xdbResetError ()
    RETURN
  END IF

	' sort query
	xdbQuerySort (hQuery1, "YEAR+ARTIST", $$SORT_ASCEND)

	' execute the query
	xdbQueryExecute(hQuery1)

	' queries do not require the index parameter - it would be ignored anyway.
	xdbMoveFirst(hQuery1, 0)

	DO UNTIL xdbEOF(hQuery1)   'process the record here using functions such as xdbFieldValue$
		year$ = xdbFieldValue$ (hQuery1, "YEAR", 0)
		artist$ = xdbFieldValue$ (hQuery1, "ARTIST", 0)
		title$ = xdbFieldValue$ (hQuery1, "TITLE", 0)
		? year$; ": "; artist$; ": "; title$
		' if you need to know the record number in the database then call
		' the xdbRecordNumber function with the Query handle, not the
		' database handle.
		RecNum = xdbRecordNumber (hQuery1)
		xdbMoveNext(hQuery1, 0)
	LOOP

	' destroy query
	xdbDestroyQuery (hQuery1)

	'	close the database and related index
  xdbClose(dbHandle)
  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
END PROGRAM